part of picsou_simulation;

class Dividend {

  Logger logger = new Logger('picsou.Dividend');

  double gross;
  double charges;
  double net;
  double netImposable;

  Dividend(this.gross, this.charges, this.net, this.netImposable);

  Map toPublicJson() {
    Map map = new Map();
    map["gross"] = roundNumber(gross);
    map["net"] = roundNumber(net);
    map["netImposable"] = roundNumber(netImposable);
    map["charges"] = roundNumber(charges);
    return map;
  }

  String toString() {
    return """
      \n
      [Dividend]
      gross = $gross
      charges = $charges
      net = $net
      netImposable = $netImposable
      """;
  }
}
