part of picsou_simulation;

abstract class ChargeEurl implements Compute {

  Logger logger = new Logger('picsou.ChargeEurl');

  ChargeEurl(this.name);

  String name;

  String toString() {
    return """
      \n
      [ChargeEurl]
      name = $name
      """;
  }
}

abstract class Compute {
  double compute(double amount);
}

class ChargeEurlComputed {

  Logger logger = new Logger('picsou.ChargeEurlComputed');

  ChargeEurl charge;
  double chargeComputed;

  ChargeEurlComputed(this.charge, this.chargeComputed);

  Map toPublicJson() {
    Map map = new Map();
    map["name"] = charge.name;
    map["amount"] = roundNumber(chargeComputed);
    return map;
  }
  String toString() {
    return """
      \n
      [ChargeEurlComputed]
      charge = $charge
      chargeComputed = $chargeComputed
      """;
  }
}
