part of picsou_simulation;


class ChargeSasGmp extends ChargeSas {

  ChargeSasGmp(String name, double tauxSalarial, double tauxPatronal)
      : super(name, tauxSalarial, tauxPatronal);

  @override
  double computePatronale(double amount) {
    if (amount >= gmpCharniere || amount == 0.00) {
      return 0.00;
    }

    if (amount <= pass) {
      return gmpAnnuelPatronal;
    }

    double amountToProcess = amount - pass;
    double partComputed = amountToProcess * tauxPatronal / 100;
    return gmpAnnuelPatronal - partComputed;
  }

  @override
  double computeSalariale(double amount) {
    if (amount >= gmpCharniere || amount == 0.00) {
      return 0.00;
    }

    if (amount <= pass) {
      return gmpAnnuelSalarial;
    }

    double amountToProcess = amount - pass;
    double partComputed = amountToProcess * tauxSalarial / 100;
    return gmpAnnuelSalarial - partComputed;
  }
}
