part of picsou_simulation;


class ChargeSasSeuils extends ChargeSas {

  double seuilFrom;
  double seuilTo;

  ChargeSasSeuils(String name, double tauxSalarial, double tauxPatronal, this.seuilFrom, this.seuilTo) : super(name, tauxSalarial, tauxPatronal);

  double compute(double amount, double taux) {

    double amountToProcess = 0.00;

    if(amount >= seuilFrom) {
      amountToProcess = amount - seuilFrom;

      if(amount >= seuilTo) {
        amountToProcess = seuilTo - seuilFrom;
      }
    }

    return amountToProcess * taux/100;
  }

  @override
  double computePatronale(double amount) {
    return compute(amount, tauxPatronal);
  }

  @override
  double computeSalariale(double amount) {
    return compute(amount, tauxSalarial);
  }
}
