part of picsou_simulation;

class SimulationSas {

  Logger logger = new Logger('picsou.SimulationSas');

  double turnover;
  double runningCost;

  Salary salarySas;
  double impotIs;
  Dividend dividend;

  double ir;
  double net;

  SimulationSas(this.turnover, this.runningCost, this.salarySas,
      this.impotIs, this.dividend, this.ir, this.net);

  String toString() {
    return """
      \n
      [SimulationSas]
      turnover = $turnover
      runningCost = $runningCost
      salarySas = $salarySas
      impotIs = $impotIs
      Dividend = $dividend
      ir = $ir
      net = $net
      """;
  }

  Map toPublicJson() {
    Map map = new Map();
    map["turnover"] = roundNumber(turnover);
    map["runningCost"] = roundNumber(runningCost);
    map["salary"] = salarySas.toPublicJson();
    map["is"] = roundNumber(impotIs);
    map["dividend"] = dividend.toPublicJson();
    map["ir"] = roundNumber(ir);
    map["net"] = roundNumber(net);
    map["pourcentageNet"] = roundNumber(net / (turnover - runningCost) * 100);

    return map;
  }
}
