part of picsou_simulation;


class ChargeEurlAllocationFamiliale extends ChargeEurl with AllocationFamiliale {

  double taux = 0.00;

  ChargeEurlAllocationFamiliale(String name) : super(name);

  double compute(double base) {
    double charges = super.compute(base);
    taux = (base / charges) * 100;
    return charges;
  }
}

abstract class AllocationFamiliale implements Compute {

  double taux1 = 2.15;
  double seuil1 = 42478.00;
  double taux2 = 5.25;
  double seuil2 = 54062.00;

  double compute(double base) {
    double taux = 0.00;

    if(base <= seuil1) {
      taux = taux1;
    }
    if(base > seuil1 && base < seuil2) {
      taux = (((seuil2 - base)/(seuil2 - seuil1))*(taux2-taux1))+taux1;
    }
    if(base >= seuil2) {
      taux = taux2;
    }

    return (base * taux) / 100;
  }
}
