part of picsou_simulation;


class ChargeEurlSeuil extends ChargeEurl with Seuil {

  ChargeEurlSeuil(String name, double taux, double seuil) : super(name) {
    this.taux = taux;
    this.seuil = seuil;
  }
}

abstract class Seuil implements Compute {

  double taux;
  double seuil;

  double compute(double base) {
    if(base < seuil) {
      return base * taux/100;
    }
    return seuil * taux/100;
  }
}
