part of picsou_simulation;


class ChargeSasCsgCrds extends ChargeSas {

  double coeff;
  double seuil;
  bool isDeductible = false;

  ChargeSasCsgCrds(String name, double tauxSalarial, double tauxPatronal, double coeff, double seuil, bool isDeductible) : super(name, tauxSalarial, tauxPatronal) {
    this.coeff = coeff;
    this.seuil = seuil;
    this.isDeductible = isDeductible;
  }

  double compute(double amount, double taux) {

    double partWithCoeff = amount*coeff;
    double partWithNoCoeff = 0.0;

    if(amount >= seuil) {
      partWithCoeff = pass*coeff;
      partWithNoCoeff = (amount-seuil);
    }

    return (partWithCoeff * taux/100) + (partWithNoCoeff * taux/100);
  }

  @override
  double computePatronale(double amount) {
    return compute(amount, tauxPatronal);
  }

  @override
  double computeSalariale(double amount) {
    return compute(amount, tauxSalarial);
  }
}