part of picsou_simulation;


ServiceSalary serviceSalary = new ServiceSalary();

class ServiceSalary {

  Logger logger = new Logger('picsou.ServiceSalary');

  double findGrossSalaryFromExtraGross(double turnover, double runningCost, double extraGross) {

    Salary salary = serviceUtil.findByDichotomy(1000, extraGross / 2, extraGross, extraGross, (newLimit) => computeSalary(newLimit), (computed) => (turnover - runningCost >= computed.extraGrossSalary), (computed) => computed.extraGrossSalary);
    return salary.grossSalary;
  }

  double findGrossSalaryFromNet(double net) {

    Salary salary = serviceUtil.findByDichotomy(1000, net, net * 2, net, (newLimit) => computeSalary(newLimit), (_) => true, (computed) => computed.netSalary);
    return salary.grossSalary;
  }

  Salary computeSalary(double grossSalary) {

    List<ChargeSasComputed> chargesComputed = charges.charges.map((ChargeSas charge) => new ChargeSasComputed(charge, charge.computeSalariale(grossSalary), charge.computePatronale(grossSalary))).toList();
    return new Salary.computeFromCharges(grossSalary, chargesComputed);
  }
}

