part of picsou_simulation;


ServiceDividend serviceDividend = new ServiceDividend();

class ServiceDividend {

  Logger logger = new Logger('picsou.ServiceDividend');

  Dividend computeDividend(double dividendBrut) {

    double dividendAfterAbattement = dividendBrut - (dividendBrut * 0.40);

    double tauxCsgCrds = 15.50;
    double impotDividend = dividendAfterAbattement * (tauxCsgCrds / 100);

    double tauxCsgCrdsDeductible = 5.10;
    double netImposable = dividendAfterAbattement - (dividendAfterAbattement * (tauxCsgCrdsDeductible / 100));

    return new Dividend(dividendBrut, impotDividend, dividendBrut - impotDividend, netImposable);
  }
}

